box = require "modules/boxcol"

-- Make this easier and set the slope distance equivalent to the x position of the character box with adjustments due to ratio (i.e. x is 6 on a 2:1 slope, therefor 6/2 is 3 and that is the slope distance)

slopes = {}
slopes.__index = slopes
allSlopes = {}

function slopes.new_slope (x,y,w,h,t)
    if ((w % h) == 0) or ((h % w) == 0) then
        local self = box.new_box(x,y,w,h,"slope")
		setmetatable (self,slopes)
		self.steps = {}
		self.slopeT = t
		if w > h then
			self.yRat = w/h
		elseif h > w then
			self.yRat = h/w
		elseif h == w then
			self.yRat = 1
		end
        table.insert(allSlopes, self)
        return self
    else
        print ("Error: Width must be a multiple of the Height")
    end
end



function slopes.inter (self,ent)
	if ent.t == "ent" then
		if self.slopeT == "br" then
			if  ent.x + ent.w <= self.x + self.w then 
				-- for i = 1, (#self.steps) do (error fix later if necessary errors come up)
				-- self.step = self.y + self.h - ((self.x - ent.x)/self.yRat) -- Downward!!!!
				self.step = self.y + self.h - ((ent.x + ent.w - self.x )/self.yRat)
				self.vDist = self.step - ent.y - ent.h
				-- finish if statement bellow
				if ent.y + ent.h > self.step and ent.y < self.y + self.h then
					ent.y = self.step - ent.h
					self.vDist = self.step - ent.y - ent.h
				end
			else self.vDist = math.huge
			end
		elseif self.slopeT == "bl" then
			if  ent.x >= self.x then 
				-- for i = 1, (#self.steps) do (error fix later if necessary errors come up)
				-- self.step = self.y + self.h - ((self.x - ent.x)/self.yRat) -- Downward!!!!
				self.step = self.y + self.h - ((self.x + self.w - ent.x )/self.yRat)
				self.vDist = self.step - ent.y - ent.h
				-- finish if statement bellow
				if ent.y + ent.h > self.step and ent.y < self.y + self.h then
					ent.y = self.step - ent.h
					self.vDist = self.step - ent.y - ent.h
				end
			else self.vDist = math.huge
			end
		elseif self.slopeT == "tr" then
		
		elseif self.slopeT == "tl" then
		
		end
	end
end

-- conflicts on which objects are closer in slope
function slopes.distance (ent)
	curDist = math.huge
	for i = 1,#allSlopes do
		local o = allSlopes [i]
		if o.t == "slope" then
			local distance = math.sqrt(math.abs(ent.centX - o.centX)^2 + math.abs(ent.centY - o.centY)^2)
			if distance < curDist then
				curDist = distance
				nearObj = o
			end
		end
		if i == #allSlopes then
			return nearObj.vDist
		end
	end
end

return slopes